#include <iostream>

using namespace std;  

string zamena(string s, int l, int d){
	for(int i=l; i<d; i++){
		if(s[i]=='1'){
			s[i]='0';
		}
		else{
			s[i]='1';
		}
	}
	return s;
}

int vrednost(string s){
	int sum=0;
	for(int i=0; i<sizeof(s); i++){
		if(s[i]=='1'){
			sum++;
		}
	}
	return sum;
}

int main() {
	int n, c, q;
	cin>>n>>c>>q;
	string s;
	cin>>s;
	
	for(int br=0; br<q; br++){
		int l, d;
		cin>>l>>d;
		s = zamena(s, l-1, d);
		cout<<vrednost(s)<<endl;
	}
	
	return 0;
}